#!/usr/home/walton/install/bin/php4
<?php
// LICENSE
/*
DiggerDiff v1.2
Copyright (c) 2003, Dave Walton
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/
// END LICENSE


// TODO:  Use curl_*() or PHP 5 to do posts (config option?)
// TODO:  Use curl_*() or PHP to do https (config option?)


require('./config.php');

if ($config['updatemode'] === 'cron') {
  if (($HTTP_SERVER_VARS['argc'] > 2) && ($HTTP_SERVER_VARS['argv'][1] === 'cron')) {
    set_time_limit(0);
    $config['agelimit'] = 0;
    $HTTP_GET_VARS['action'] = 'cron';
    $HTTP_GET_VARS['urlfile'] = ereg_replace("[^[:alnum:]]", '', $HTTP_SERVER_VARS['argv'][2]);
// TODO: query string comes in as $HTTP_SERVER_VARS['argv'][0], so this needs work
//  } else {
//    echo "Error in command line.\n";
//    exit();
  }
}


function build_filename($version, $config, $urlfile, $urlmd5) {
  if (($version === 'old') || ($version === 'new')) {
    $filename = $config['pagepath'] . "$urlfile/" . $config[$version . 'path'] . $urlmd5;
  } else {
    $filename = FALSE;
  }
  return($filename);
}


function load_file($name, $compress=FALSE, $implode=FALSE) {
  if ($compress === TRUE) {
    $data = @gzfile($name);
  } else {
    $data = @file($name);
  }
  if (($implode !== FALSE) && is_array($data)) {
    $data = implode($implode, $data);
  }
  return($data);
}


function save_file($name, $contents, $compress=FALSE) {
  if ($compress === TRUE) {
    $fp = gzopen($name, 'w');
    gzwrite($fp, $contents);
    gzclose($fp);
  } else {
    $fp = fopen($name, 'w');
    fwrite($fp, $contents);
    fclose($fp);
  }
}


// Used by: action_cron, action_diff, action_save
function load_urls($config) {
  global $HTTP_SESSION_VARS;
  $urlfile = $HTTP_SESSION_VARS['urlfile'];
  $comments = $HTTP_SESSION_VARS['comments'];
  $sorturls = $HTTP_SESSION_VARS['sorturls'];
  $sitedata = array();

  $urlfile = $config['pagepath'] . "$urlfile.dat";
  $urllist = load_file($urlfile, FALSE, FALSE);
  if ($sorturls === TRUE) {
    natcasesort($urllist);
  }
  reset($urllist);

  $index = 0;
  foreach ($urllist as $line) {
    $line = trim($line);
    if (empty($line)) {
      continue;
    }
    if (($comments === FALSE) && ($line[0] === '#')) {
      continue;
    }
    $sitedata[$index] = parse_line($line);
    if (empty($sitedata[$index]['title'])) {
      $sitedata[$index]['title'] = $sitedata[$index]['url'];
    }
    $index++;
  }

  return($sitedata);
}


// Used by: action_cron, action_list
function fetch_pages($firstkey, $lastkey, $config, $sitedata) {
  global $HTTP_SESSION_VARS;
  $urlfile = $HTTP_SESSION_VARS['urlfile'];

  // make sure $config['newpath'] exists
  $dirname = $config['pagepath'];
  if (!is_dir($dirname)) {
    mkdir($dirname, 0755);
  }
  $dirname .= "$urlfile/";
  if (!is_dir($dirname)) {
    mkdir($dirname, 0755);
  }
  $dirname .= $config['newpath'];
  if (!is_dir($dirname)) {
    mkdir($dirname, 0755);
  }

  $output = '';
  for ($key=$firstkey; $key<=$lastkey; $key++) {
    $now = time();
    $url = $sitedata[$key]['url'];
    $title = $sitedata[$key]['title'];
    $urlmd5 = $sitedata[$key]['md5'];
    $postdata = $sitedata[$key]['postdata'];
    $regexes = $sitedata[$key]['regex'];
    $newfile = build_filename('new', $config, $urlfile, $urlmd5);

    if ($title[0] === '#') {
      continue;
    }

    $newfiletime = @filemtime($newfile);
    if ($newfiletime !== FALSE) {
      $currentcontents = load_file($newfile, $config['compress'], FALSE);
      if (!empty($currentcontents) && ($newfiletime > ($now - $config['agelimit']))) {
        continue;
      }
    }

    if ($config['updatemode'] === 'cron') {
      $output .= "Fetching [$title]... ";
    }

    if (!empty($postdata)) {
      $newcontents = shell_exec($config['postcmd'] . " '$postdata' '$url'");
      if (empty($newcontents)) {
        $newcontents = FALSE;
      } else {
        // put into an array for consistency with file()
        $newcontents = array($newcontents);
      }
    // use parse_url() here??
    } else if (strtolower(substr($url, 0, 8)) === 'https://') {
      // For PHP >= 4.0.3
      //$newcontents = shell_exec($config['httpscmd'] . " " . escapeshellarg($url));
      $newcontents = shell_exec($config['httpscmd'] . " '$url'");
      if (empty($newcontents)) {
        $newcontents = FALSE;
      } else {
        // put into an array for consistency with file()
        $newcontents = array($newcontents);
      }
    } else {
      // TODO:  This doesn't support redirects, but newer versions of PHP can
      $newcontents = @file($url);
    }

    if ($newcontents === FALSE) {
      $newcontents = '';
    } else {
      $newcontents = implode('', $newcontents);
      // detect line endings and clean up accordingly
      if (strpos($newcontents, "\r\n") !== FALSE) {
        // DOS file
        $newcontents = explode("\r\n", $newcontents);
      } else if (strpos($newcontents, "\n") !== FALSE) {
        // Unix file
        $newcontents = explode("\n", $newcontents);
      } else if (strpos($newcontents, "\r") !== FALSE) {
        // Mac file
        $newcontents = explode("\r", $newcontents);
      } else {
        // Unknown file?
	// Gotta put it back into an array for consistency
	$newcontents = array($newcontents);
      }
      $newcontents = implode("\n", $newcontents);

      // strip out any specified patterns
      foreach ($regexes as $regex) {
	$divider = $regex[0];
        $divcount = substr_count($regex, $divider);
	// MUST be in form "/search/replace/[modifiers]"
	if ($divcount !== 3) {
	  $output .= "(Warning: $divcount dividers in regex [$regex].) ";
	  continue;
	}
	$regparts = explode($divider, $regex);
	// Rearrange to "/search/[modifiers]" and "replace"
	$search = $divider . $regparts[1] . $divider;
	if (!empty($regparts[3])) {
	  // disallow the 'e' modifier for security reasons
	  $search .= str_replace('e', '', $regparts[3]);
	}
	$replace = empty($regparts[2]) ? '' : stripcslashes($regparts[2]);
	$newcontents = preg_replace($search, $replace, $newcontents);
      }
    }

    if (!file_exists($newfile) || (md5($newcontents) !== md5($currentcontents))) {
      save_file($newfile, $newcontents, $config['compress']);
    }

    if ($config['updatemode'] === 'cron') {
      if (empty($newcontents)) {
        $output .= "ERROR\n";
      } else {
        $output .= "Success\n";
      }
    }
  }
  return($output);
}


// Used by: load_urls, action_edit
function parse_line($line) {
  $linedata = explode(chr(0x09), $line);
  $fields = count($linedata);
  $title = '';
  $url = '';
  $postdata = '';
  $regexes = array();
  $md5 = '';

  if (empty($line)) {
    // Format: blank
  } else if ($line[0] === '#') {
    // Format: #Comment
    $title = $line;
  } else {
    if (isset($linedata[2]) && (strtoupper(substr($linedata[2], 0, 5)) === 'POST ')) {
      // Format: Title<TAB>URL<TAB>POST PostData[<TAB>Regex]...
      $title = $linedata[0];
      $url = $linedata[1];
      $postdata = substr($linedata[2], 5);
      for ($field=3; $field<$fields; $field++) {
        $regexes[] = $linedata[$field];
      }
    } else if (isset($linedata[1])) {
      // Format: Title<TAB>URL[<TAB>Regex]...
      $title = $linedata[0];
      $url = $linedata[1];
      for ($field=2; $field<$fields; $field++) {
        $regexes[] = $linedata[$field];
      }
    } else {
      // Format: URL
      $url = $linedata[0];
    }
    $md5 = md5($url . $postdata);
  }

  $linedata = array();
  $linedata['title'] = $title;
  $linedata['url'] = $url;
  $linedata['postdata'] = $postdata;
  $linedata['regex'] = $regexes;
  $linedata['md5'] = $md5;
  return($linedata);
}


// Used by: action_diff, action_frame, action_save, action_view
function print_header($style = 'trans', $title = '', $head = '') {
  $output = '';
  $output .= "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
  switch ($style) {
    case 'frame':
      $output .= "<!DOCTYPE html\n";
      $output .= "   PUBLIC \"-//W3C//DTD XHTML 1.0 Frameset//EN\"\n";
      $output .= "   \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd\">\n";
      break;
    case 'strict':
      $output .= "<!DOCTYPE html\n";
      $output .= "   PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"\n";
      $output .= "   \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n";
      break;
    case 'trans':
    default:
      $output .= "<!DOCTYPE html\n";
      $output .= "   PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n";
      $output .= "   \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
      break;
  }
  $output .= "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">\n";
  $output .= "<head>\n";
  $output .= "  <title>DiggerDiff $title</title>\n";
  $output .= "$head\n";
  $output .= "</head>\n\n";

  return($output);
}


function set_session($var, $type, $default) {
  global $HTTP_GET_VARS, $HTTP_SESSION_VARS;

  // Work around the problem that unchecked checkboxes aren't sent.
  // TODO:  This hack isn't enough to let me do type 'barray'
  if (($type === 'bool') && isset($HTTP_GET_VARS['apply'])) {
    if (!isset($HTTP_GET_VARS[$var])) {
      $HTTP_GET_VARS[$var] = FALSE;
    }
  }

  if (isset($HTTP_GET_VARS[$var])) {
    switch($type) {
      case 'bool':
        if ($HTTP_GET_VARS[$var] === 'TRUE') {
	  $val = TRUE;
	} else {
	  $val = FALSE;
	}
        break;
      case 'farray':
        if (!is_array($HTTP_GET_VARS[$var])) {
	  // TODO:  is \r\n universal, or should I be doing line-ending checks???
	  $HTTP_GET_VARS[$var] = explode("\r\n", $HTTP_GET_VARS[$var]);
	}
	$val = array();
	foreach ($HTTP_GET_VARS[$var] as $line) {
	  if (!empty($line)) {
	    $val[] = (float)$line;
	  }
	}
        break;
      case 'float':
        $val = (float)$HTTP_GET_VARS[$var];
        break;
      case 'iarray':
        if (!is_array($HTTP_GET_VARS[$var])) {
	  // TODO:  is \r\n universal, or should I be doing line-ending checks???
	  $HTTP_GET_VARS[$var] = explode("\r\n", $HTTP_GET_VARS[$var]);
	}
	$val = array();
	foreach ($HTTP_GET_VARS[$var] as $line) {
	  if (!empty($line)) {
	    $val[] = (int)$line;
	  }
	}
        break;
      case 'int':
        $val = (int)$HTTP_GET_VARS[$var];
        break;
      case 'sarray':
        if (!is_array($HTTP_GET_VARS[$var])) {
	  // TODO:  is \r\n universal, or should I be doing line-ending checks???
	  $HTTP_GET_VARS[$var] = explode("\r\n", $HTTP_GET_VARS[$var]);
	}
	$val = array();
	foreach ($HTTP_GET_VARS[$var] as $line) {
	  if (!empty($line)) {
	    $line = trim((string)$line);
	    if (get_magic_quotes_gpc()) {
	      $line = stripslashes($line);
	    }
	    $val[] = $line;
	  }
	}
        break;
      case 'string':
      default:
        $val = trim((string)$HTTP_GET_VARS[$var]);
	if (get_magic_quotes_gpc()) {
	  $val = stripslashes($val);
	}
        break;
    }
    session_register($var);
    $HTTP_SESSION_VARS[$var] = $val;
  } else if (!session_is_registered($var)) {
    $val = $default;
    session_register($var);
    $HTTP_SESSION_VARS[$var] = $val;
  } else {
    $val = $HTTP_SESSION_VARS[$var];
  }

  return($val);
}


function set_var($var, $default) {
  global $HTTP_GET_VARS, $HTTP_POST_VARS;

  $val = $default;
  if (isset($HTTP_GET_VARS[$var])) {
    $val = $HTTP_GET_VARS[$var];
  }
  if (isset($HTTP_POST_VARS[$var])) {
    $val = $HTTP_POST_VARS[$var];
  }

  if (is_array($default)) {
    $val = (array)$val;
  } else if (is_bool($default)) {
    if (strcasecmp($val, 'TRUE') === 0) {
      $val = TRUE;
    } else {
      $val = FALSE;
    }
  } else if (is_float($default)) {
    $val = (float)$val;
  } else if (is_integer($default)) {
    $val = (int)$val;
  } else if (is_string($default)) {
    $val = (string)$val;
  } else {
    // should never get here!
    $val = NULL;
  }

  return($val);
}


// ==================================================


// Initialize input variables

// What action to perform
// Default action set with mainlayout below
$action = set_var('action', '');

// Line to edit (edit)
$line = set_var('line', 0);
// Edited line data (edit)
$linedata = set_var('linedata', array());
// Edit mode (edit), Search mode (search)
$mode = set_var('mode', '');

// MD5 of URL to operate on (diff, edit, fetch, save, view)
$site = set_var('site', '');
$site = ereg_replace("[^[:alnum:]]", '', $site);
// Old or New version (view)
$version = strtolower(set_var('version', ''));
// Rendered or Source view (diff)
$view = strtolower(set_var('view', ''));

// String to search for in local pages (search)
$search = set_var('search', '');
if (get_magic_quotes_gpc()) {
  $search = stripslashes($search);
}

// ==================================================

// Set up session variables
$default = $config['default'];
session_start();

// URL file
$urlfile = set_session('urlfile', 'string', $default['urlfile']);
$newurlfile = set_var('newurlfile', '');
if (!empty($newurlfile)) {
  $urlfile = ereg_replace("[^[:alnum:]]", '', $newurlfile);
  if (!is_file($config['pagepath'] . "$urlfile.dat")) {
    touch($config['pagepath'] . "$urlfile.dat");
  }
} else {
  $urlfile = ereg_replace("[^[:alnum:]]", '', $urlfile);
}
session_register('urlfile');
$HTTP_SESSION_VARS['urlfile'] = $urlfile;
if (!is_file($config['pagepath'] . "$urlfile.dat")) {
  echo "ERROR:  URL file '$urlfile' does not exist!\n";
  exit();
}

// Current page (edit, fetch, frame, list, save)
$page = set_session('page', 'int', $default['page']);

// Site filter string (list)
$filtersite = set_session('filtersite', 'string', $default['filtersite']);

// Main window layout (frame)
$mainlayout = set_session('mainlayout', 'string', $default['mainlayout']);
if (empty($action) || isset($HTTP_GET_VARS['mainlayout'])) {
  switch($mainlayout) {
    case 'split':
      $action = 'frame';
      break;
    case 'single':
    default:
      $action = 'list';
      break;
  }
}

// Main window frame divider (frame)
$maindivider = set_session('maindivider', 'string', $default['maindivider']);

// Main window frame size (frame)
$mainsize = set_session('mainsize', 'int', $default['mainsize']);

// Diff frame layout (diff)
$difflayout = set_session('difflayout', 'string', $default['difflayout']);

// Split diff frame divider (diff)
$diffdivider = set_session('diffdivider', 'string', $default['diffdivider']);

// Single diff style (diff)
$diffstyle = set_session('diffstyle', 'string', $default['diffstyle']);

// Diff frame size (diff)
$diffsize = set_session('diffsize', 'int', $default['diffsize']);

// Diff formatting mode - source view (diff)
$diffsourcemode = set_session('diffsourcemode', 'string', $default['diffsourcemode']);

// Diff formatting mode - rendered view (diff)
$diffrendermode = set_session('diffrendermode', 'string', $default['diffrendermode']);

// Display diff lines starting with these chars
$diffshow = set_session('diffshow', 'string', $default['diffshow']);

// Display this many sites per page
$perpage = set_session('perpage', 'int', $default['perpage']);

// Rows for site list
$rows = set_session('rows', 'sarray', $default['rows']);

// Columns for site list
$columns = set_session('columns', 'sarray', $default['columns']);

// Sort list?
$sorturls = set_session('sorturls', 'bool', $default['sorturls']);

// Display comments in list?
$comments = set_session('comments', 'bool', $default['comments']);

// Display page ranges?
$ranges = set_session('ranges', 'bool', $default['ranges']);

// Edit select list lines
$editselectlines = set_session('editselectlines', 'int', $default['editselectlines']);

// Edit select list width
$editselectwidth = set_session('editselectwidth', 'int', $default['editselectwidth']);

// Edit field width
$editwidth = set_session('editwidth', 'int', $default['editwidth']);

// Edit field lines
$editlines = set_session('editlines', 'int', $default['editlines']);


switch ($action) {
  case 'config':
    include_once('./dd_config.php');
    action_config($config);
    break;
  case 'cron':
    include_once('./dd_cron.php');
    action_cron($config);
    break;
  case 'diff':
    include_once('./dd_diff.php');
    echo action_diff($config, $site, $view);
    break;
  case 'edit':
    include_once('./dd_edit.php');
    action_edit($config, $mode, $line, $linedata, $site);
    break;
  case 'fetch':
    include_once('./dd_fetch.php');
    action_fetch($config, $site);
    break;
  case 'frame':
    include_once('./dd_frame.php');
    action_frame($config);
    break;
  case 'list':
    include_once('./dd_list.php');
    echo action_list($config);
    break;
  case 'save':
    include_once('./dd_save.php');
    echo action_save($config, $action, $site);
    break;
  case 'search':
    include_once('./dd_search.php');
    echo action_search($config, $search, $mode);
    break;
  case 'view':
    include_once('./dd_view.php');
    action_view($config, $site, $version);
    break;
  default:
    echo print_header('strict');
    echo "<body>\n";
    echo "<h1>Invalid action.</h1>\n";
    echo "</body>\n\n";
    echo "</html>\n";
    break;
}

exit;

?>
